// Ispitianje generike klase nizova.

#include "niz4.h"
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
using namespace std;

double sluc(double min, double max) {     // Generator sluajnih brojeva.
  return min + rand() / (RAND_MAX + 1.) * (max - min);
}

struct Tacka {                            // Struktura taaka.
  double x = 0, y = 0;
  Tacka() =default;
  Tacka(double a, double b) { x = a; y = b; }
  friend ostream& operator<<(ostream& it, const Tacka& t)
    { return it << '(' << t.x << ',' << t.y << ')'; }
};

int main() {
  Niz<int> nizi(20);                      // Niz celih brojeva:
  while (nizi.dodaj(sluc(-99, 100)));     // - punjenje niza,
  cout << nizi << endl;
  nizi.izbaci([](int x){return x<0;});    // - izostavljanje negativnih
  cout << nizi << endl;                   //   elemenata,
  nizi.izbaci([](int x){return x%2!=0;}); // - izostavljanje neparnih
  cout << nizi << endl;                   //   elemenata.
  cout << endl;
  
  Niz<Tacka> nizt1(5);                    // Niz taaka:
  while (nizt1.dodaj(Tacka(sluc(-5,5),    // - punjenje niza,
                           sluc(-5,5))));
  cout << setprecision(3) << nizt1 << endl;
  Tacka s(3, -4);
  Niz<Tacka> nizt2(nizt1.radi<Tacka>(     // - pomeranje elemenata,
                   [s](Tacka t){return Tacka(s.x+t.x,s.y+t.y);}));
  cout << nizt2 << endl;
  Niz<double> nizd(nizt2.radi<double>(    // - rastojanja od koord. po.
                   [](Tacka t){return sqrt(t.x*t.x+t.y*t.y);}));
  cout << setprecision(6) << nizd << endl;
}
